﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace ParallelProgramming
{
    class Program
    {
        static Random RNG = new Random();
        static char[] Seed = { 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z' };



        static void Main(string[] args)
        {
            LinearTest(12000000);
            ParallelTest(12000000);

            Console.ReadKey();
        }

        static void LinearTest(int size)
        {
            string[] infoArray = new string[size];

            Console.WriteLine("Linear Start");

            StringBuilder sb = new StringBuilder("");

            for (int i = 0; i < infoArray.Length; i++)
            {
                for (int j = 0; j < 10; j++)
                {
                    sb.Append(Seed[RNG.Next(Seed.Length)]);
                }

                infoArray[i] = sb.ToString();
                sb.Clear();
            }

            Console.WriteLine("Linear Done!");
        }

        static void ParallelTest(int size)
        {
            int threadCount = Environment.ProcessorCount;

            string[] infoArray = new string[size];

            int lotSize = size / threadCount;

            Console.WriteLine("Parallel Start");

            for (int i = 0; i < threadCount; i++)
            {
                int start = lotSize * i;
                int stop = start + lotSize;
                new Thread(() => { ParallelWorker(infoArray, start, stop); }).Start();
            }

            // Wait until all threads are done.
            // This is a very bad practice.
            // It's here for demonstration purposes.
            while (infoArray.Contains(null))
            {
            }

            Console.WriteLine("Parallel Done!");
        }

        static void ParallelWorker(string[] lot, int start, int finish)
        {
            char[] Seed = { 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z' };
            Random RNG = new Random();

            StringBuilder sb = new StringBuilder("");

            for (int i = start; i < finish; i++)
            {
                for (int j = 0; j < 10; j++)
                {
                    sb.Append(Seed[RNG.Next(Seed.Length)]);
                }
                lot[i] = sb.ToString();
                sb.Clear();
            }
        }
    }
}
